module MMDARexx where

import Amiga

import qualified MMDARexxTrigCmd
import MMDARexxTrigCmd(MMDARexxTrigCmd)

data MMDARexx = MMDARexx
  { reserved   :: UWORD
  , trigcmdlen :: UWORD
  , trigcmd    :: Maybe MMDARexxTrigCmd
  }
  deriving (Show)

peek :: MEM -> PTR -> IO MMDARexx
peek m p = do
  reserved'   <- peekUWORD m (p+0)
  trigcmdlen' <- peekUWORD m (p+2)
  trigcmd'''  <- peekPTR   m (p+4)
  trigcmd'    <- MMDARexxTrigCmd.peek m $? trigcmd'''
  return $ MMDARexx
    reserved' trigcmdlen' trigcmd'
