module Pretty where

pretty :: String -> String
pretty = pretty' 0

pretty' :: Int -> String -> String
pretty' level []     = "\n"
pretty' level (c:cs) = case c of
  ' ' -> pretty' level cs
  '=' -> " = " ++ pretty' level cs
  '{' -> "{\n" ++ indent (level+1) ++        pretty' (level+1) cs
  '}' -> "\n"  ++ indent (level-1) ++ "}" ++ pretty' (level-1) cs
  '[' -> "[\n" ++ indent (level+1) ++        pretty' (level+1) cs
  ']' -> "\n"  ++ indent (level-1) ++ "]" ++ pretty' (level-1) cs
  '(' -> "(\n" ++ indent (level+1) ++        pretty' (level+1) cs
  ')' -> "\n"  ++ indent (level-1) ++ ")" ++ pretty' (level-1) cs
  ',' -> ",\n" ++ indent level ++ pretty' level cs
  otherwise -> c : pretty' level cs

indent :: Int -> String
indent level = replicate (level*4) ' '
